hadoop-common-issues mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Yongjun Zhang (JIRA)" <j...@apache.org>
Subject [jira] [Updated] (HADOOP-12604) Exception may be swallowed in KMSClientProvider
Date Sat, 05 Dec 2015 07:56:11 GMT

     [ https://issues.apache.org/jira/browse/HADOOP-12604?page=com.atlassian.jira.plugin.system.issuetabpanels:all-tabpanel
]

Yongjun Zhang updated HADOOP-12604:
-----------------------------------
    Status: Patch Available  (was: Open)

Hi [~stevel@apache.org], 

Thanks for your comments, would you please help taking a look at the patch? Thanks.




> Exception may be swallowed in KMSClientProvider
> -----------------------------------------------
>
>                 Key: HADOOP-12604
>                 URL: https://issues.apache.org/jira/browse/HADOOP-12604
>             Project: Hadoop Common
>          Issue Type: Bug
>          Components: kms
>            Reporter: Yongjun Zhang
>            Assignee: Yongjun Zhang
>              Labels: supportability
>         Attachments: HADOOP-12604.001.patch
>
>
> In KMSClientProvider# createConnection
> {code}
>       try {
>         is = conn.getInputStream();
>         ret = mapper.readValue(is, klass);
>       } catch (IOException ex) {
>         if (is != null) {
>           is.close(); <== close may throw exception
>         }
>         throw ex;
>       } finally {
>         if (is != null) {
>           is.close();
>         }
>       }
>     }
> {code}
> {{ex}} may be swallowed when {{close}} highlighted in the code throws exception.  Thanks
[~qwertymaniac] for pointing this out.
> BTW, I think we should be able to consolidate the two {{is.close()}} in the above code,
so we don't close the same stream twice. The one in the {{finally block}} may be called after
an exception is thrown or not, and it may throw exception too, we need to be careful not to
swallow exception here too.



--
This message was sent by Atlassian JIRA
(v6.3.4#6332)

Mime
View raw message